using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using CustomUIControls;

namespace ImageListPopupDemo
{
	/// <summary>
	/// Description rsume de Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private ImageList imageList;
		private ImageList imageList2;
		private ImageListPopup ilp;
		private ImageListPopup ilp2;
		private System.Windows.Forms.PictureBox pictureBox1;
		/// <summary>
		/// Variable ncessaire au concepteur.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Requis pour la prise en charge du Concepteur Windows Forms
			//
			InitializeComponent();

			// Creation of the First ImageList
			imageList = new ImageList();
			imageList.ImageSize=new Size(24,24);
			imageList.ColorDepth = ColorDepth.Depth24Bit;
			imageList.Images.AddStrip(new Bitmap(GetType(),"emoticons.bmp"));
			imageList.TransparentColor = Color.FromArgb(255,0,255);

			// Creation of the Second ImageList
			imageList2 = new ImageList();
			imageList2.ImageSize=new Size(32,32);
			imageList2.ColorDepth = ColorDepth.Depth24Bit;
			imageList2.Images.AddStrip(new Bitmap(GetType(),"imagelist.bmp"));
			imageList2.TransparentColor = Color.FromArgb(255,0,255);

			// Creation of the first ImageListPopup
			ilp = new ImageListPopup();
			ilp.EnableDragDrop = true;
			ilp.Init(imageList,8,8,5,4);
			ilp.ItemClick += new ImageListPopupEventHandler(OnItemClicked);
			
			// Creation of the second ImageListPopup, all properties must be
			// Set before the Init() call
			ilp2 = new ImageListPopup();
			ilp2.BackgroundColor = Color.FromArgb(241,241,241);
			ilp2.BackgroundOverColor = Color.FromArgb(102,154,204);
			ilp2.HLinesColor = Color.FromArgb(182,189,210);
			ilp2.VLinesColor = Color.FromArgb(182,189,210);
			ilp2.BorderColor = Color.FromArgb(0,0,0);
			ilp2.EnableDragDrop = true;
			ilp2.Init(imageList2,12,12,6,2);
			ilp2.ItemClick += new ImageListPopupEventHandler(OnItemClicked);
		}

		/// <summary>
		/// Nettoyage des ressources utilises.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Mthode requise pour la prise en charge du concepteur - ne modifiez pas
		/// le contenu de cette mthode avec l'diteur de code.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button2 = new System.Windows.Forms.Button();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(8, 80);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(104, 32);
			this.button1.TabIndex = 0;
			this.button1.Text = "Demo 1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(128, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Selected Image:";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.pictureBox1});
			this.groupBox1.Location = new System.Drawing.Point(8, 0);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(272, 72);
			this.groupBox1.TabIndex = 2;
			this.groupBox1.TabStop = false;
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(176, 80);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(104, 32);
			this.button2.TabIndex = 0;
			this.button2.Text = "Demo 2";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.Color.White;
			this.pictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBox1.Location = new System.Drawing.Point(216, 16);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(48, 48);
			this.pictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage;
			this.pictureBox1.TabIndex = 3;
			this.pictureBox1.TabStop = false;
			// 
			// Form1
			// 
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(288, 117);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label1,
																		  this.groupBox1,
																		  this.button1,
																		  this.button2});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "Form1";
			this.Text = "ImageListPopup Demo";
			this.DragDrop += new System.Windows.Forms.DragEventHandler(this.Form1_DragDrop);
			this.DragEnter += new System.Windows.Forms.DragEventHandler(this.Form1_DragEnter);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Point d'entre principal de l'application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			Point pt = PointToScreen(new Point(button1.Left, button1.Bottom));
			ilp.Show(pt.X,pt.Y);
		}
		
		private void button2_Click(object sender, System.EventArgs e)
		{
			Point pt = PointToScreen(new Point(button2.Left, button2.Bottom));
			ilp2.Show(pt.X,pt.Y);
		}

		private void OnItemClicked(object sender, ImageListPopupEventArgs e)
		{
			label1.Text = "Selected Image: " + e.SelectedItem;
			if (sender.Equals(ilp))
				pictureBox1.Image = imageList.Images[e.SelectedItem];
			else
				pictureBox1.Image = imageList2.Images[e.SelectedItem];

		}

		private void Form1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			e.Effect = DragDropEffects.All;
		}

		private void Form1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			if (e.Data.GetDataPresent(DataFormats.Bitmap))
				pictureBox1.Image = (Image) e.Data.GetData(DataFormats.Bitmap);
			if (e.Data.GetDataPresent(DataFormats.Text))
				label1.Text = "Selected Image: " + (string) e.Data.GetData(DataFormats.Text);
		}
	}
}
